import {
  Type,
  PropertyKeyType,
  Annotation,
  DecoratorHelper,
} from '@overflow/core-js';


export interface RPCSubscriberDecoratorAttribute {
  method: string;
}

export function RPCSubscriber(attribute: RPCSubscriberDecoratorAttribute): MethodDecorator {
  return function <T>(target: Object, propertyKey: PropertyKeyType, descriptor: TypedPropertyDescriptor<T>)
    : TypedPropertyDescriptor<T> | void {

    DecoratorHelper.register<RPCSubscriberDecoratorAttribute>(attribute, target, propertyKey, descriptor);
  };
}

// import {
//   Type,
//   PropertyKeyType,
// } from '@loafer/core';

// import {
//   Decorator,
//   DecoratorFactory,
// } from '@loafer/decorator';

// export interface RPCSubscriberDecoratorAttribute {
//   method: string;
// }

// export class RPCSubscriberDecorator extends Decorator<RPCSubscriberDecoratorAttribute> {
//   public constructor(config: RPCSubscriberDecoratorAttribute) {
//     super(config);
//   }

//   public methodDecorator = <T>(target: Object, propertyKey: PropertyKeyType,
//     descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void => {
//   }

// }

// export const RPCSubscriber = DecoratorFactory.create<RPCSubscriberDecoratorAttribute>(RPCSubscriberDecorator);
